(function ($, Drupal) {
  Drupal.behaviors.simpleFavsHeart = {
    attach: function (context, settings) {
      once('simple-favs-heart', '.simple-favs-heart', context).forEach(function (element) {
        const $heart = $(element);
        const contentId = $heart.data('id');

        function updateVisual() {
          if (Drupal.behaviors.simpleFavs.isInFavs(contentId)) {
            $heart.addClass('active').find('.heart-icon').text('♥');
          }
          else {
            $heart.removeClass('active').find('.heart-icon').text('♡');
          }
        }

        updateVisual();

        $heart.on('click', function () {
          if (Drupal.behaviors.simpleFavs.isInFavs(contentId)) {
            Drupal.behaviors.simpleFavs.removeFromFavs(contentId);
          }
          else {
            Drupal.behaviors.simpleFavs.addToFavs(contentId);
          }
          updateVisual();
        });

        $heart.on('keydown', function (e) {
          if (e.key === 'Enter' || e.key === ' ') {
            e.preventDefault();
            $heart.trigger('click');
          }
        });
      });
    }
  };
})(jQuery, Drupal);
